"use strict";var _validate=require("./validate.js");




const fastCartesian=function(arrays){
(0,_validate.validateInput)(arrays);

if(arrays.length===0){
return[];
}

const loopFunc=getLoopFunc(arrays.length);
const result=[];
loopFunc(arrays,result);
return result;
};

const getLoopFunc=function(length){
const cachedLoopFunc=cache[length];

if(cachedLoopFunc!==undefined){
return cachedLoopFunc;
}

const loopFunc=mGetLoopFunc(length);

cache[length]=loopFunc;
return loopFunc;
};

const cache={};










const mGetLoopFunc=function(length){
const indexes=Array.from({length},getIndex);
const repeatA=repeat.bind(null,indexes);

const start=repeatA(
index=>`for (const value${index} of arrays[${index}]) {`);

const middle=repeatA(index=>`value${index}`,", ");
const end=repeatA(()=>"}");


return new Function(
"arrays",
"result",
`${start}\nresult.push([${middle}])\n${end}`);

};

const getIndex=function(value,index){
return String(index);
};

const repeat=function(indexes,mapper,separator="\n"){
return indexes.map(mapper).join(separator);
};



module.exports=fastCartesian;
//# sourceMappingURL=main.js.map